///getConnectionsForCluster(blocks)
/**
 * getConnectionsForCluster :: Set Block -> Set Connection
 * 
 * Returns a set of all connections connecting two blocks within the cluster of blocks.
 *
 * @param blocks a set of blocks
 */

var blocks = argument0;
var connections = ds_set_create();

with (Connection) {
  if (self.source.target != noone && self.drain.target != noone)
    if (ds_set_exists(blocks, self.source.target.parent) && ds_set_exists(blocks, self.drain.target.parent))
      ds_set_add(connections, id);
}

return connections;

