///getInstObjName(i)
/**
 * getInstObjName :: Any -> String
 * 
 * Returns the given instance/object/keyword as a string.
 */

if (!is_real(argument0))
  return "[NaN "+string(argument0)+"]";

if (argument0 >= 0) {
  if (object_exists(argument0))
    return "<"+object_get_name(argument0)+">";
  if (instance_exists(argument0))
    return "<"+object_get_name(argument0.object_index)+"@"+string(argument0)+">";

  return "[unknown "+string(argument0)+"]";
}

switch (argument0) {
case global:
  return "global";
case -7:
  return "local";
case self:
  return "self";
case other:
  return "other";
case noone:
  return "noone";
case all:
  return "all";
}

return "[unknown "+string(argument0)+"]";

