///string_base(val, base)
/**
 * string_base :: Integer -> Integer -> String
 *
 * Converts an integer to a string using a given base.
 *
 * @param val the number to convert
 * @param base the number base to use
 * @returns a string representation of the number
 */

var val = floor(argument0);
var base = floor(argument1);
var symbols = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";

if (base == 10)
  return string(val);

if (val < 0)
  return "-"+string_base(val, base);

if (base == 1)
  return string_repeat("1", val);

if (base <= 0 || base > string_length(symbols)) {
  show_error("Unsupported base '"+string(base)+"'.", false);
  return "0";
}

if (val == 0)
  return "0";



for (var str = ""; val > 0; val = val div base)
  str = string_char_at(symbols, 1+(val mod base))+str;

return str;

