///ds_set_is_disjoint(a, b)
/**
 * ds_set_is_disjoint :: Set a -> Set a -> Boolean
 *
 * Returns whether sets `a` and `b` are disjoint.
 *
 * @param a one set
 * @param b another set
 * @returns true if a and b have no common element, false otherwise
 */

var a = argument0;
var b = argument1;

for (var el = ds_set_first(a); ds_set_exists(a, el); el = ds_set_next(a, el))
  if (ds_set_exists(b, el))
    return false;

return true;

