///ds_set_is_subset(a, b)
/**
 * ds_set_is_subset :: Set a -> Set a -> Boolean
 *
 * Returns whether set `a` is a subset of set `b`.
 *
 * @param a one set
 * @param b another set
 * @returns true if all elements of a appear in b, false otherwise
 */

var a = argument0;
var b = argument1;

for (var el = ds_set_first(a); ds_set_exists(a, el); el = ds_set_next(a, el))
  if (!ds_set_exists(b, el))
    return false;

return true;

